-- Some flesh paradise only elements from the former paradiseillusion which now applies here.
--Kirby sky and textures on centerpiece. Shoutouts to RoyKirbs for Kirby plush Textures.
--local paradiseillusion = 2

local function kirbMake(l,mo)
	P_SetupLevelSky(1126, true)
	for s in sectors.iterate
	 if s.floorpic == "VSNAKF41" or s.floorpic == "OMRBLL33"
		s.floorpic = "KRBCHKR"
	 end
	 if s.ceilingpic == "VSNAKF41" or s.ceilingpic == "OMRBLL33"
		s.ceilingpic = "KRBCHKR"
	 end
	end
end
addHook("LinedefExecute", kirbMake,"KIRBYFY")

--Modifies Things
local function thingEdit()
	--Thing edits. Removes fog and dripping water; also changes plant colors.
	for mo in thinkers.iterate("mobj")
		if mo.type == MT_WATERDRIP or mo.type == MT_EERIEFOG or mo.type == MT_EERIEFOGGEN
			P_RemoveMobj(mo)
		end
	end
	for i = 0, #mapthings - 1
		if mapthings[i].type == mobjinfo[MT_BUSH].doomednum
			mapthings[i].mobj.color = SKINCOLOR_WALNUT
		end
		if mapthings[i].type == mobjinfo[MT_GFZFLOWER3].doomednum
			mapthings[i].mobj.color = SKINCOLOR_TEA
		end
	end
end
addHook("LinedefExecute", thingEdit,"FPMOD")

local function fleshfoliage()
	for i = 0, #mapthings - 1
		if mapthings[i].type == mobjinfo[MT_BUSH].doomednum
			mapthings[i].mobj.scale = 5*mapthings[i].mobj.scale/2
			mapthings[i].mobj.color = SKINCOLOR_CRIMSON
			mapthings[i].mobj.sprite = SPR_FPDC
			mapthings[i].mobj.frame = A
		end
		if mapthings[i].type == mobjinfo[MT_GFZFLOWER3].doomednum
			mapthings[i].mobj.scale = 5*mapthings[i].mobj.scale/2
			mapthings[i].mobj.color = SKINCOLOR_LAVENDER
			mapthings[i].mobj.sprite = SPR_FPDC
			mapthings[i].mobj.frame = B
		end
	end
end
addHook("LinedefExecute",fleshfoliage,"FPFLOW")

local function tounge(l,mo,s) --Mystery sounds without the hassle of a layer of goo water.
	if not (leveltime % (TICRATE/7) == 0) or (ISALTERMODE == true) return end
	if (P_RandomChance(FRACUNIT/2) and (leveltime % TICRATE == 0)) and P_IsObjectOnGround(mo)
			S_StartSound(mo, sfx_floush)
	end
	if P_IsObjectOnGround(mo) and (mo.player.speed > 7*FRACUNIT)
		local splish = P_SpawnMobj(mo.x, mo.y, mo.z, MT_SPLISH)
		K_MatchGenericExtraFlags(mo,splish)
		splish.destscale = mo.scale
		P_SetScale(splish, mo.scale)
		S_StartSound(mo, sfx_ghit)
	end
end
addHook("LinedefExecute",tounge,"TONGUE")

addHook("MapLoad",function(n)
	if not mapheaderinfo[gamemap].trueparadise == true
		return
	end
	if 	((paradiseillusion.value == 1 or paradiseillusion.value == 0) and encoremode == true) or (paradiseillusion.value == 3)
		P_LinedefExecute(1997) --Executor that supresses encore sky channge.
	end
	
	if ISALTERMODE == false
		return
	end
	for l in lines.iterate
	--Disable Dynamic Vslopes. Ideal method, but need to stop floor movement.
			--[[if l.special == 799
				l.frontsector.tag = 0
				--P_RemoveThinker(l.frontsector)
				l.frontsector.floordata = NULL
				l.frontsector.ceilingdata = NULL
				l.frontsector.floorspeed = 0 
				l.frontsector.ceilspeed = 0]]
			if l.special == 54
					l.frontsector.ceilingheight = l.backsector.ceilingheight
					l.frontsector.floorheight = l.backsector.floorheight
		--Silence Goo
			elseif l.special == 414 and l.frontside.toptexture == _G["sfx_ghit"] 
				l.frontside.toptexture = _G["sfx_none"]
		--Move Invis Goo
			elseif l.special == 259 
			--and l.backside.toptexture == 200061
				l.frontsector.floorheight = -9000*FRACUNIT
				l.frontsector.ceilingheight = -9000*FRACUNIT
			end
	end
end)

--Spawn a tracker object (like the wanted object above the heads of the blessed)
--Do a custom exit to flesh eden when a blessed player finishes OR the majority are blessed.
--Only look at the players who finished, no one else.
freeslot("S_EDENBLESSING","SPR_EDBL")

states[S_EDENBLESSING] = {
        sprite = SPR_EDBL,
        frame = FF_FULLBRIGHT|A,
        tics = -1,
        action = none,
        var1 = 0,
        var2 = 64,
        nextstate = S_EDENBLESSING
}

local function edenblessing(l,mo,s)
	if mo.player.fledbless ~= true and not modeattacking
		--S_StartSound(nil,_G["sfx_wizact"],mo.player)
		S_StartSound(nil,sfx_ncitem,mo.player)
		mo.player.fledbless = true
		if P_CanPickupItem(mo.player, 1)
			mo.player.kartstuff[k_itemroulette] = 1
			mo.player.kartstuff[k_roulettetype] = 1
		end
		K_DoSneaker(mo.player,0)	
		P_LinedefExecute(1996,mo,s)
	else
		P_DamageMobj(mo,nil,nil,10000)
	end
end
addHook("LinedefExecute",edenblessing,"EDENBLS")



addHook("MobjThinker",function(mo)
	if (mo.player.fledbless == true) and((not mo.player.fledindicator) or (mo.player.fledindicator.valid == false)) and leveltime >2
		mo.player.fledindicator = P_SpawnMobj(mo.x,mo.y,mo.z,MT_OVERLAY)
		mo.player.fledindicator.target = mo
		mo.player.fledindicator.state = S_EDENBLESSING
	end
end,MT_PLAYER)

addHook("MapLoad",function(map)
	for p in players.iterate
		if p.fledbless == true
			p.fledbless = false
		end
	end
	return
end)
local function edenwarp()
	G_SetCustomExitVars(1021,2)
	G_ExitLevel()
end

--Warp to flesh eden, majority or the best player gets it.
local function Edenvote1(l,mo,s)
	if mo.player.exiting >= 1 and (mo.player.kartstuff[k_position] <= 1) and mo.player.fledbless == true
		edenwarp()
	end
end
addHook("LinedefExecute",Edenvote1,"EDVOTE")

local numplayers = 0
local edenplayers = 1
local function Edenvote2(l,mo,s)
 if mo.player.kartstuff[k_position] > 1 and mo.player.exiting >= 1 
	numplayers = 0
	edenplayers = 1
	for p in players.iterate
		if p.spectator continue end
		numplayers = $1 + 1
		if p.fledbless == true 
			edenplayers = $1 + 1
		end
	end
	if FixedDiv(edenplayers,numplayers) >= (65*FRACUNIT/100) 
		edenwarp()
	end
 end

end
addHook("LinedefExecute",Edenvote2,"EDVOTE2")